WoodSound = {}
WoodSound.modDirectory = g_currentModDirectory

function WoodSound:loadMap(name)
	self.spec_woodSound = {}
	local spec = self.spec_woodSound
	
	spec.samplesLogs = {}
	spec.samplesGround = {}
	spec.samplesFall = {}
	spec.samples = {}
	spec.samples['logs'] = spec.samplesLogs
	spec.samples['ground'] = spec.samplesGround
	spec.samples['fall'] = spec.samplesFall
	spec.logs = {}
	spec.tempDist = {}
	spec.tempDistGround = {}
	spec.logsInfo = ""
	spec.logsInfo2 = ""
	spec.logsInfo3 = ""
	spec.timer = 0
	spec.timerSet = 200
	spec.log = nil
	spec.log2 = nil
	spec.logCenter = nil
	spec.logCenter2 = nil
	spec.logTop = nil
	spec.logBottom = nil
	spec.debug = false
	spec.sampleNo = 0
	spec.curSplitShapeSizeX = 0
	spec.modActive = true
	spec.countId = 75
	spec.startId = 1
	spec.endId = spec.countId
	spec.logsPlay = 0
	
	self:createTriggerAndSamples()
end
function WoodSound:keyEvent(unicode, sym, modifier, isDown)
end
function WoodSound:createTriggerAndSamples()
	local spec = self.spec_woodSound
	
	spec.trigger = g_i3DManager:loadSharedI3DFile('trigger.i3d', g_modsDirectory..'/FS19_WoodSound/', true, true)
	g_currentMission.triggerVehicle = I3DUtil.indexToObject(spec.trigger, '0|0')
	spec.soundNodeVehicle = I3DUtil.indexToObject(spec.trigger, '0|0|0')
	spec.samplesLogs = {}
	spec.samplesGround = {}
	spec.samplesFall = {}
	spec.samples = {}
	spec.samples['logs'] = spec.samplesLogs
	spec.samples['ground'] = spec.samplesGround
	spec.samples['fall'] = spec.samplesFall
	if g_client ~= nil  then
		local soundsFile = WoodSound.modDirectory.."sounds/sounds.xml"
		spec.soundsXml = loadXMLFile("WoodSound_xml", soundsFile)
		for k,samples in pairs(spec.samples) do
			local i = 0
			while true do
				local baseName = string.format("sounds."..k.."(%d)", i)
				if not hasXMLProperty(spec.soundsXml, baseName) then
					break
				end
				local sample = g_soundManager:loadSampleFromXML(spec.soundsXml, baseName, "woodSound", WoodSound.modDirectory, spec.soundNodeVehicle, 1, AudioGroup.VEHICLE, self.i3dMappings, self)
				table.insert(samples, sample)
				i = i + 1
			end
		end
	end
end
function WoodSound:onDeleteWS()
	local spec = self.spec_woodSound
	if g_currentMission.controlledVehicleLast ~= nil then
		if g_currentMission.controlledVehicleLast == self then
			if g_currentMission.triggerVehicle ~= nil then
				removeTrigger(g_currentMission.triggerVehicle)
				g_currentMission.controlledVehicleLast = nil
			end
		end
	end
end
function WoodSound:update(dt)		
	local spec = self.spec_woodSound
	
	--[[if g_currentMission.controlledVehicle ~= nil then
		if g_currentMission.controlledVehicle.spec_woodHarvester ~= nil then
			local spec2 = g_currentMission.controlledVehicle.spec_woodHarvester
			if spec2.curSplitShape ~= nil then
				local sizeX, sizeY, sizeZ, numConvexes, numAttachments = getSplitShapeStats(spec2.curSplitShape)
				if sizeX ~= nil then
					spec.curSplitShapeSizeX = sizeX
					local x,y,z = getWorldTranslation(g_currentMission.controlledVehicle.spec_woodHarvester.cutNode)
					Utils.renderTextAtWorldPosition(x, y, z, 'Tree: '..string.format("%.1f", sizeX)..' m', getCorrectTextSize(0.016), 0)
				end
			else
				spec.curSplitShapeSizeX = 0
			end
		else
			spec.curSplitShapeSizeX = 0
		end
	elseif g_currentMission.player ~= nil then
		if g_currentMission.player:hasHandtoolEquipped() then
			local x,y,z = getWorldTranslation(g_currentMission.player.chainsawSplitShapeFocus)
			local nx,ny,nz = localDirectionToWorld(g_currentMission.player.chainsawSplitShapeFocus, 1,0,0)
			local yx,yy,yz = localDirectionToWorld(g_currentMission.player.chainsawSplitShapeFocus, 0,1,0)
			local splitShape, minY, maxY, minZ, maxZ = findSplitShape(x,y,z, nx,ny,nz, yx,yy,yz, 5, 5)
			if splitShape ~=0 then
				local sizeX, sizeY, sizeZ, numConvexes, numAttachments = getSplitShapeStats(splitShape)
				spec.curSplitShapeSizeX = sizeX
				Utils.renderTextAtWorldPosition(x, y, z, 'Tree: '..string.format("%.1f", sizeX)..' m', getCorrectTextSize(0.016), 0)
			else
				spec.curSplitShapeSizeX = 0
			end
		else
			spec.curSplitShapeSizeX = 0
		end
	end]]
	
	--[[if Input.isKeyPressed(Input.KEY_KP_plus) then
		if spec.keyPressed1 == false then
			spec.keyPressed1 = true
			--print('timer plus 50')
			--spec.timerSet = spec.timerSet + 50
			print('pitch - '..spec.samples['logs'][spec.sampleNo].current.pitch)
			--spec.samples['logs'][spec.sampleNo].current.pitch = spec.samples['logs'][spec.sampleNo].current.pitch + 0.05
			spec.samples['ground'][spec.sampleNo].current.pitch = spec.samples['ground'][spec.sampleNo].current.pitch + 0.05
			print('pitch - '..spec.samples['logs'][spec.sampleNo].current.pitch)
		end
	else
		spec.keyPressed1 = false
	end
	if Input.isKeyPressed(Input.KEY_KP_minus) then
		if spec.keyPressed2 == false then
			spec.keyPressed2 = true
			--print('timer minus 50')
			--spec.timerSet = spec.timerSet - 50
			--spec.samples['logs'][spec.sampleNo].current.pitch = spec.samples['logs'][spec.sampleNo].current.pitch - 0.05
			spec.samples['ground'][spec.sampleNo].current.pitch = spec.samples['ground'][spec.sampleNo].current.pitch - 0.05
		end
	else
		spec.keyPressed2 = false
	end
	if Input.isKeyPressed(Input.KEY_KP_multiply) then
		if spec.keyPressed3 == false then
			spec.keyPressed3 = true
			spec.sampleNo = spec.sampleNo + 1
		end
	else
		spec.keyPressed3 = false
	end
	if Input.isKeyPressed(Input.KEY_KP_divide) then
		if spec.keyPressed4 == false then
			spec.keyPressed4 = true
			spec.sampleNo = spec.sampleNo - 1
		end
	else
		spec.keyPressed4 = false
	end
	if Input.isKeyPressed(Input.KEY_o) then
		if spec.keyPressed5 == false then
			spec.keyPressed5 = true
			spec.debug = not spec.debug
			--DebugUtil.printTableRecursively(g_currentMission.player.baseInformation.currentHandtool,"-",0,5)
		end
	else
		spec.keyPressed5 = false
	end
	if Input.isKeyPressed(Input.KEY_m) then
		if spec.keyPressed6 == false then
			spec.keyPressed6 = true
			spec.modActive = not spec.modActive
		end
	else
		spec.keyPressed6 = false
	end]]
	
	if not entityExists(g_currentMission.triggerVehicle) then
		--print('trigger not exists')
		self:createTriggerAndSamples()
	end
	if g_currentMission.player ~= nil and g_currentMission.controlPlayer then
		if not spec.playerTriggerLinked then
				removeTrigger(g_currentMission.triggerVehicle)
				unlink(g_currentMission.triggerVehicle)
			addTrigger(g_currentMission.triggerVehicle, "triggerCallbackWoodSound", self)
			link(g_currentMission.player.pickUpKinematicHelperNode, g_currentMission.triggerVehicle)
			spec.playerTriggerLinked = true
			--print('player trigger linked')
		end
	elseif not g_currentMission.controlPlayer or g_currentMission.player == nil then
		if spec.playerTriggerLinked then
			removeTrigger(g_currentMission.triggerVehicle)
			unlink(g_currentMission.triggerVehicle)
			spec.playerTriggerLinked = false
			--print('player trigger unlinked')
		end
	end
	if g_currentMission.controlledVehicle ~= nil then
		if g_currentMission.controlledVehicleLast == nil or (g_currentMission.controlledVehicleLast ~= nil and g_currentMission.controlledVehicle ~= g_currentMission.controlledVehicleLast) then
			if g_currentMission.controlledVehicleLast ~= nil and g_currentMission.controlledVehicleLast.vehicleTriggerLinked then
				removeTrigger(g_currentMission.triggerVehicle)
				unlink(g_currentMission.triggerVehicle)
				g_currentMission.controlledVehicleLast.vehicleTriggerLinked = false
				--print(g_currentMission.controlledVehicleLast:getFullName()..' vehicle trigger unlinked 1')
			end
			if not g_currentMission.controlledVehicle.vehicleTriggerLinked then
				addTrigger(g_currentMission.triggerVehicle, "triggerCallbackWoodSound", self)
				link(g_currentMission.controlledVehicle.rootNode, g_currentMission.triggerVehicle)
				g_currentMission.controlledVehicle.vehicleTriggerLinked = true
				--print(g_currentMission.controlledVehicle:getFullName()..' vehicle trigger linked')
				g_currentMission.controlledVehicle.onDeleteBackup = g_currentMission.controlledVehicle.delete
				g_currentMission.controlledVehicle.delete = Utils.prependedFunction(g_currentMission.controlledVehicle.delete, WoodSound.onDeleteWS)
			end
			g_currentMission.controlledVehicleLast = g_currentMission.controlledVehicle
		end
	elseif g_currentMission.controlledVehicleLast ~= nil then
		if g_currentMission.controlledVehicleLast.vehicleTriggerLinked then
			--print(g_currentMission.controlledVehicleLast:getFullName()..' vehicle trigger unlinked 2')
			g_currentMission.controlledVehicleLast.vehicleTriggerLinked = false
			g_currentMission.controlledVehicleLast = nil
		end
	end
	local count = 0
	local count2 = 0
	local count3 = 0
	local index = 1
	local totalCount = 0
	if (g_currentMission.controlPlayer and g_currentMission.player ~= nil) or g_currentMission.controlledVehicle ~= nil then
		spec.timer = spec.timer + dt
		if spec.timer >= spec.timerSet then
			spec.timer = 0
			spec.logsPlay = 0
			spec.logsInfo = ""
			spec.logsInfo2 = ""
			spec.logsInfo3 = ""
			if spec.modActive then
				for i,v in pairs(spec.logs) do
					totalCount = totalCount + 1
				end
				for i,v in pairs(spec.logs) do
					count = count + 1
					if index >= spec.startId and index <= spec.endId then
						count3 = count3 + 1
						if entityExists(v) then
							local x,y,z = getWorldTranslation(v)
							local nx,ny,nz = localDirectionToWorld(v, 0,1,0);
							local lenBelow, lenAbove = getSplitShapePlaneExtents(v, x,y,z,nx,ny,nz)
							--if spec.debug then spec.logsInfo = spec.logsInfo .. 'Log '..i..' : '..v..' bel-'..string.format("%.3f",lenBelow)..' abo-'..string.format("%.3f",lenAbove)..'\n' end
							spec.logCenter = getChild(v,'logCenter')
							spec.logTop = getChild(v,'logTop')
							spec.logBottom = getChild(v,'logBottom')
							if spec.logCenter ~= nil and spec.logTop ~= nil and spec.logBottom ~= nil then
								for j,vv in pairs(spec.logs) do
									local diff = 0
									if entityExists(vv) then
										count2 = count2 + 1
										if v ~= vv then
											spec.logTop2 = getChild(vv,'logTop')
											spec.logCenter2 = getChild(vv,'logCenter')
											spec.logBottom2 = getChild(vv,'logBottom')
											local a,b,c = getWorldTranslation(spec.logCenter)
											local x,y,z = getWorldTranslation(spec.logTop2)
											local distTop = MathUtil.vector3Length(a - x, b - y, c - z)
											local x,y,z = getWorldTranslation(spec.logCenter2)
											local distCenter = MathUtil.vector3Length(a - x, b - y, c - z)
											local x,y,z = getWorldTranslation(spec.logBottom2)
											local distBottom = MathUtil.vector3Length(a - x, b - y, c - z)
											if spec.tempDist[v] == nil then
												spec.tempDist[v] = {}
												spec.tempDist[v][vv] = {}
												spec.tempDist[v][vv][1] = distTop
												spec.tempDist[v][vv][2] = distCenter
												spec.tempDist[v][vv][3] = distBottom
												spec.tempDist[v][vv][4] = false
											elseif spec.tempDist[v][vv] == nil then
												spec.tempDist[v][vv] = {}
												spec.tempDist[v][vv][1] = distTop
												spec.tempDist[v][vv][2] = distCenter
												spec.tempDist[v][vv][3] = distBottom
												spec.tempDist[v][vv][4] = false
											else
												diffTop = spec.tempDist[v][vv][1] - distTop
												diffCenter = spec.tempDist[v][vv][2] - distCenter
												diffBottom = spec.tempDist[v][vv][3] - distBottom
												spec.tempDist[v][vv][1] = distTop
												spec.tempDist[v][vv][2] = distCenter
												spec.tempDist[v][vv][3] = distBottom
												if ((diffTop > 0.05 and distTop < 0.7) or (diffCenter > 0.05 and distCenter < 0.7) or (diffBottom > 0.05 and distBottom < 0.7)) then
												if spec.tempDist[vv] ~= nil and not spec.tempDist[vv][v][4] then
													if g_client ~= nil  then
														if WoodSound.checkIsInRange(self,spec.logCenter,nil) then
															spec.logsPlay = spec.logsPlay + 1
															spec.logsTarget = spec.logCenter
															spec.tempDist[v][vv][4] = true
														end
													end
												end
												end
												--spec.logsInfo2 = spec.logsInfo2 .. 'Log '..v..' - '..vv..' - distTop: '..string.format("%.3f",distTop)..' - diffTop: '..string.format("%.3f",diffTop)..'\n'
											end
										end
									else
										spec.logs[vv] = nil
										spec.tempDist[vv] = nil
									end
								end
								local x,y,z = getWorldTranslation(spec.logTop)
								local terrainY = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode,x,y,z)
								local distanceGroundTop = y - terrainY
								local topHeight = y
								local x,y,z = getWorldTranslation(spec.logCenter)
								local terrainY = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode,x,y,z)
								local distanceGroundCenter = y - terrainY
								local x,y,z = getWorldTranslation(spec.logBottom)
								local terrainY = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode,x,y,z)
								local distanceGroundBottom = y - terrainY
								local bottomHeight = y
								local sizeX, sizeY, sizeZ, numConvexes, numAttachments = getSplitShapeStats(v)
								local diffTopBottom = {}
								if spec.tempDistGround[v] == nil then
									spec.tempDistGround[v] = {}
									spec.tempDistGround[v][1] = distanceGroundTop
									spec.tempDistGround[v][2] = distanceGroundCenter
									spec.tempDistGround[v][3] = distanceGroundBottom
									spec.tempDistGround[v][4] = topHeight
									spec.tempDistGround[v][5] = bottomHeight
									spec.tempDistGround[v][6] = false
								else
									local diffGroundTop = spec.tempDistGround[v][1] - distanceGroundTop
									local diffGroundCenter = spec.tempDistGround[v][2] - distanceGroundCenter
									local diffGroundBottom = spec.tempDistGround[v][3] - distanceGroundBottom
									local diffTopHeight = spec.tempDistGround[v][4] - topHeight
									local diffBottomHeight = spec.tempDistGround[v][5] - bottomHeight
									spec.tempDistGround[v][1] = distanceGroundTop
									spec.tempDistGround[v][2] = distanceGroundCenter
									spec.tempDistGround[v][3] = distanceGroundBottom
									spec.tempDistGround[v][4] = topHeight
									spec.tempDistGround[v][5] = bottomHeight
									diffTopBottom[1] = topHeight - bottomHeight
									diffTopBottom[2] = sizeX * 0.95
									--if spec.debug then print(v..' topHeight - '..topHeight..', diffTopHeight - '..diffTopHeight..', distGroundBot - '..distanceGroundBottom) end
									--if spec.debug then print(v..' diffTopBottom[1] - '..diffTopBottom[1]..', diffTopBottom[2] - '..diffTopBottom[2]..', sizeX - '..sizeX) end
									if diffTopBottom[1] >= diffTopBottom[2] and diffTopHeight > 0.1 and distanceGroundBottom <= 2 and not spec.tempDistGround[v][6] and numAttachments > 5 then
										if g_client ~= nil  then
											if WoodSound.checkIsInRange(self,spec.logCenter,spec.logBottom) then
												if not WoodSound.checkPlayingSamples(self,spec.samplesFall) then
													--if not spec.debug then print(v..' topHeight - '..topHeight..', diffTopHeight - '..diffTopHeight..', distGroundBot - '..distanceGroundBottom) end
													--if not spec.debug then print(v..' diffTopBottom[1] - '..diffTopBottom[1]..', diffTopBottom[2] - '..diffTopBottom[2]..', sizeX - '..sizeX) end
													self:playSound(true, spec.logBottom, 'fall', sizeX)
													spec.tempDistGround[v][6] = true
												end
											end
										end
									elseif (distanceGroundTop < 0.35 and diffGroundTop > 0.05) or (distanceGroundCenter < 0.35 and diffGroundCenter > 0.05) or (distanceGroundBottom < 0.35 and diffGroundBottom > 0.05) then
										local target
										local target2
										if distanceGroundTop < 0.35 and diffGroundTop > 0.05 then
											target = spec.logTop
											target2 = 'top'
										elseif distanceGroundCenter < 0.35 and diffGroundCenter > 0.05 then
											target = spec.logCenter
											target2 = 'center'
										elseif distanceGroundBottom < 0.35 and diffGroundBottom > 0.05 then
											target = spec.logBottom
											target2 = 'bottom'
										end
										if g_client ~= nil  then
											if WoodSound.checkIsInRange(self, target, nil) then
												if not WoodSound.checkPlayingSamples(self,spec.samplesGround) then
													--print('play ground - '..target2)
													self:playSound(true, target, 'ground', nil)
													break
												end
											end
										end
									end
									if spec.debug then
										--spec.logsInfo2 = spec.logsInfo2 .. 'Log '..v..' - topH: '..string.format("%.2f",topHeight)..', diffTopH: '..string.format("%.2f",diffTopHeight)..', diffTopBot1: '..string.format("%.2f",diffTopBottom[1])..', diffTopBot2: '..string.format("%.2f",diffTopBottom[2])..' - '..numAttachments..'\n'
									end
								end
							end
						else
							spec.logs[v] = nil
							spec.tempDist[v] = nil
							spec.tempDistGround[v] = nil
						end
					end
					index = index + 1
				end
				if g_client ~= nil  then
					if spec.logsPlay >= 1 then
						if not WoodSound.checkPlayingSamples(self,spec.samplesLogs) then
							--print('playing logs - '..spec.logsPlay)
							self:playSound(true, spec.logsTarget, 'logs', spec.logsPlay)
							spec.logsPlayLast = spec.logsPlay
						elseif spec.logsPlayLast > 1 then
							--print('playing logs - '..spec.logsPlay..' - extra')
							self:playSound(true, spec.logsTarget, 'logs', 1)
							spec.logsPlayLast = 1
						end
					end
				end
				spec.startId = spec.endId + 1
				spec.endId = spec.endId + spec.countId
				if spec.startId >= totalCount then
					spec.startId = 1
					spec.endId = spec.countId
					for i,v in pairs(spec.tempDist) do
						for j,w in pairs(v) do
							w[4] = false
						end
					end
				end
			end
			--[[spec.logsInfo3 = spec.logsInfo3 .. 'controlledVehicle - '..(g_currentMission.controlledVehicle ~= nil and g_currentMission.controlledVehicle:getFullName() or 'nil')..'\n'
			spec.logsInfo3 = spec.logsInfo3 .. 'controlledVehicleLast - '..(g_currentMission.controlledVehicleLast ~= nil and g_currentMission.controlledVehicleLast:getFullName() or 'nil')..'\n'
			spec.logsInfo3 = spec.logsInfo3 .. 'count - '..count..'\n'
			spec.logsInfo3 = spec.logsInfo3 .. 'count2 - '..count2..'\n'
			spec.logsInfo3 = spec.logsInfo3 .. 'count3 - '..count3..'\n'
			spec.logsInfo3 = spec.logsInfo3 .. 'startId - '..spec.startId..'\n'
			spec.logsInfo3 = spec.logsInfo3 .. 'endId - '..spec.endId..'\n'
			spec.logsInfo3 = spec.logsInfo3 .. 'logsPlay - '..spec.logsPlay..'\n'
			spec.logsInfo3 = spec.logsInfo3 .. 'timerSet - '..spec.timerSet..'\n'
			spec.logsInfo3 = spec.logsInfo3 .. 'sampleNo - '..spec.sampleNo..'\n'
			if spec.sampleNo ~= 0 then spec.logsInfo3 = spec.logsInfo3 .. 'samplePitch - '..spec.samples['ground'][spec.sampleNo].current.pitch..'\n' end
			spec.logsInfo3 = spec.logsInfo3 .. 'debug - '..tostring(spec.debug)..'\n'
			spec.logsInfo3 = spec.logsInfo3 .. 'modActive - '..tostring(spec.modActive)..'\n'
			spec.logsInfo3 = spec.logsInfo3 .. 'curSplitShapeSizeX - '..string.format("%.1f",spec.curSplitShapeSizeX)..' m\n']]
		end
	else
		spec.logsInfo = ""
		spec.logsInfo2 = ""
		spec.logsInfo3 = ""
		spec.logs = {}
	end
end
function WoodSound:triggerCallbackWoodSound(triggerId,otherId,onEnter,onLeave,onStay)
	local spec = self.spec_woodSound
	
	if onEnter then
		local splitType = g_splitTypeManager:getSplitTypeByIndex(getSplitType(otherId))
		if splitType ~= nil and spec.logs[otherId] == nil then
			local sizeX, sizeY, sizeZ, numConvexes, numAttachments = getSplitShapeStats(otherId)
			--print('trigger enter - '..tostring(otherId)..', '..getMass(otherId)..' t, '..getVolume(otherId)..' m3, '..sizeX..' m, rigid - '..getRigidBodyType(otherId))
			if getVolume(otherId) > 0.01 then
				if entityExists(otherId) and (getRigidBodyType(otherId) == 'Dynamic' or getRigidBodyType(otherId) == 'Kinematic') then
					spec.logs[otherId] = otherId
					self:createLogTrans(otherId)
				end
			end
		end
	elseif onLeave then
		--print('trigger leave - '..tostring(otherId))
		local splitType = g_splitTypeManager:getSplitTypeByIndex(getSplitType(otherId))
		if splitType ~= nil and spec.logs[otherId] == otherId then
			if entityExists(otherId) and (getRigidBodyType(otherId) == 'Dynamic' or getRigidBodyType(otherId) == 'Kinematic') then
				spec.logs[otherId] = nil
				spec.tempDist[otherId] = nil
				spec.tempDistGround[otherId] = nil
			end
		end
	end
end
function WoodSound:createLogTrans(shape)
	if getChild(shape,'logCenter') == 0 then
		local x,y,z = getWorldTranslation(shape)
		local nx,ny,nz = localDirectionToWorld(shape, 0,1,0);
		local lenBelow, lenAbove = getSplitShapePlaneExtents(shape, x,y,z,nx,ny,nz);
		local sizeX, sizeY, sizeZ = getSplitShapeStats(shape)
		local logCenter = createTransformGroup("logCenter")
		link(shape, logCenter)
		setTranslation(logCenter, 0,-lenBelow+(sizeX/2),0)
	end
	if getChild(shape,'logTop') == 0 then
		local x,y,z = getWorldTranslation(shape)
		local nx,ny,nz = localDirectionToWorld(shape, 0,1,0);
		local lenBelow, lenAbove = getSplitShapePlaneExtents(shape, x,y,z,nx,ny,nz);
		local sizeX, sizeY, sizeZ = getSplitShapeStats(shape)
		local logTop = createTransformGroup("logTop")
		link(shape, logTop)
		setTranslation(logTop, 0,lenAbove,0)
	end
	if getChild(shape,'logBottom') == 0 then
		local x,y,z = getWorldTranslation(shape)
		local nx,ny,nz = localDirectionToWorld(shape, 0,1,0);
		local lenBelow, lenAbove = getSplitShapePlaneExtents(shape, x,y,z,nx,ny,nz);
		local sizeX, sizeY, sizeZ = getSplitShapeStats(shape)
		local logBottom = createTransformGroup("logBottom")
		link(shape, logBottom)
		setTranslation(logBottom, 0,-lenBelow,0)
	end
end
function WoodSound:playSound(isPlaying, linkNode, samples, sizeX)
	local spec = self.spec_woodSound
	
	if spec.samples[samples] ~= nil and isPlaying and linkNode ~= nil then
		if not WoodSound.checkPlayingSamples(self,spec.samplesFall) then
			local x,y,z = getWorldTranslation(linkNode)
			local a,b,c = worldToLocal(g_currentMission.triggerVehicle, x,y,z)
			setTranslation(spec.soundNodeVehicle, a,b,c)
		end
		local count = table.getn(spec.samples[samples])
		local number = math.random(1, count)
		if samples == 'logs' then
			if sizeX > 1 then
				number = math.random(1, 3)
			else
				number = math.random(4, count)
			end
		elseif samples == 'ground' and WoodSound.checkPlayingSamples(self,spec.samplesFall) then
			number = 2
		elseif samples == 'fall' then
			if sizeX < 16 then
				number = 1
			elseif sizeX > 30 then
				number = math.random(6, 7)
			else
				number = math.random(2, 5)
			end
		end
		if spec.sampleNo ~= 0 then
			number = math.random(spec.sampleNo, spec.sampleNo)
		end
		--print('--------------------------------'..samples..' - play sound '..number..' from '..linkNode)
        g_soundManager:playSample(spec.samples[samples][number])
	end
end
function WoodSound:checkPlayingSamples(samples)
	
	local isPlaying = false
	for i,sample in pairs(samples) do
		if g_soundManager:getIsSamplePlaying(sample) then
			isPlaying = true
		end
	end
	return isPlaying
end
function WoodSound:checkIsInRange(shape,shape2)
	local inRange = false
	local target
	if g_currentMission.controlPlayer and g_currentMission.player ~= nil then
		target = g_currentMission.player.rootNode
	elseif g_currentMission.controlledVehicle ~= nil then
		target = g_currentMission.controlledVehicle.rootNode
	end
	if target ~= nil and shape ~= nil and entityExists(shape) then
		local x,y,z = getWorldTranslation(target)
		local a,b,c = getWorldTranslation(shape)
		local distance = MathUtil.vector3Length(x-a, y-b, z-c)
		if distance < 100 then
			inRange = true
		end
		if shape2 ~= nil and entityExists(shape2) then
			local a,b,c = getWorldTranslation(shape2)
			local distance = MathUtil.vector3Length(x-a, y-b, z-c)
			if distance < 100 then
				inRange = true
			end
		end
	end
	return inRange
end
function WoodSound:draw()
	local spec = self.spec_woodSound
	
	--[[local source = spec.soundNodeVehicle
	local x,y,z = getWorldTranslation(source)
	local nx, ny, nz = localDirectionToWorld(source, 10, 0, 0)
	local yx, yy, yz = localDirectionToWorld(source, 0, 10, 0)
	local zx, zy, zz = localDirectionToWorld(source, 0, 0, 10)
	drawDebugLine(x,y,z, 1, 0, 0, x + nx, y + ny, z + nz, 1, 0, 0)
	drawDebugLine(x,y,z, 0, 1, 0, x + yx, y + yy, z + yz, 0, 1, 0)
	drawDebugLine(x,y,z, 0, 0, 1, x + zx, y + zy, z + zz, 0, 0, 1)
	if g_client ~= nil  then
		renderText(0.69, 0.85, 0.013, spec.logsInfo3)
		if spec.debug == true then
			setTextBold(false)
			setTextAlignment(RenderText.ALIGN_LEFT)
			setTextColor(0.6307, 0.6307, 0.6307, 1)
			--renderText(0.55, 0.75, 0.013, spec.logsInfo)
			--renderText(0.59, 0.75, 0.013, spec.logsInfo2)
			
			for i,v in pairs(spec.logs) do
				if entityExists(v) then
					if getChild(v,'logCenter') ~= 0 then
						local logCenter = getChild(v,'logCenter')
						if logCenter ~= 0 and logCenter ~= nil then
							local x,y,z = getWorldTranslation(logCenter)
							local nx, ny, nz = localDirectionToWorld(v, 3, 0, 0)
							local yx, yy, yz = localDirectionToWorld(v, 0, 3, 0)
							local zx, zy, zz = localDirectionToWorld(v, 0, 0, 3)
							drawDebugLine(x,y,z, 1, 0, 0, x + nx, y + ny, z + nz, 1, 0, 0)
							drawDebugLine(x,y,z, 0, 1, 0, x + yx, y + yy, z + yz, 0, 1, 0)
							drawDebugLine(x,y,z, 0, 0, 1, x + zx, y + zy, z + zz, 0, 0, 1)
						end
					end
					if getChild(v,'logTop') ~= 0 then
						local logTop = getChild(v,'logTop')
						if logTop ~= 0 and logTop ~= nil then
							local x,y,z = getWorldTranslation(logTop)
							local nx, ny, nz = localDirectionToWorld(v, 5, 0, 0)
							local yx, yy, yz = localDirectionToWorld(v, 0, 5, 0)
							local zx, zy, zz = localDirectionToWorld(v, 0, 0, 5)
							drawDebugLine(x,y,z, 1, 0, 0, x + nx, y + ny, z + nz, 1, 0, 0)
							drawDebugLine(x,y,z, 0, 1, 0, x + yx, y + yy, z + yz, 0, 1, 0)
							drawDebugLine(x,y,z, 0, 0, 1, x + zx, y + zy, z + zz, 0, 0, 1)
						end
					end
					if getChild(v,'logBottom') ~= 0 then
						local logBottom = getChild(v,'logBottom')
						if logBottom ~= 0 and logBottom ~= nil then
							local x,y,z = getWorldTranslation(logBottom)
							local nx, ny, nz = localDirectionToWorld(v, 1, 0, 0)
							local yx, yy, yz = localDirectionToWorld(v, 0, 1, 0)
							local zx, zy, zz = localDirectionToWorld(v, 0, 0, 1)
							drawDebugLine(x,y,z, 1, 0, 0, x + nx, y + ny, z + nz, 1, 0, 0)
							drawDebugLine(x,y,z, 0, 1, 0, x + yx, y + yy, z + yz, 0, 1, 0)
							drawDebugLine(x,y,z, 0, 0, 1, x + zx, y + zy, z + zz, 0, 0, 1)
						end
					end
					local x,y,z = getWorldTranslation(v)
					local nx, ny, nz = localDirectionToWorld(v, 5, 0, 0)
					local yx, yy, yz = localDirectionToWorld(v, 0, 5, 0)
					local zx, zy, zz = localDirectionToWorld(v, 0, 0, 5)
					drawDebugLine(x,y,z, 1, 0, 0, x + nx, y + ny, z + nz, 1, 0, 0)
					drawDebugLine(x,y,z, 0, 1, 0, x + yx, y + yy, z + yz, 0, 1, 0)
					drawDebugLine(x,y,z, 0, 0, 1, x + zx, y + zy, z + zz, 0, 0, 1)
				end
			end
		end
	end]]
end

function WoodSound:deleteMap()
end
function WoodSound:mouseEvent(posX, posY, isDown, isUp, button)
end
addModEventListener(WoodSound)